//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   if(PopupMenu1->Items->Count > 0)
   {
      for(int i=0; i <= PopupMenu1->Items->Count-1; i++)
      {
         PopupMenu1->Items->Items[i]->OnMeasureItem = ExpandMenuItemWidth;
         PopupMenu1->Items->Items[i]->OnDrawItem = DrawNewItem;
      }
   }
   CreateVerticalFont();
   Icon = new TIcon;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenu1Popup(TObject *Sender)
{
   VerticalBarDrawn = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ExpandMenuItemWidth(TObject *Sender, TCanvas *ACanvas, int &Width, int &Height)
{
   Width += TEXT_SPACE;
}

//---------------------------------------------------------------------------

void TForm1::CreateVerticalFont()
{
   ZeroMemory(&VerticalFont,sizeof(VerticalFont));
   VerticalFont.lfHeight = -18;
   VerticalFont.lfEscapement = 900;
   VerticalFont.lfOrientation = 900;
   VerticalFont.lfWeight = FW_BOLD;
   StrPCopy(VerticalFont.lfFaceName, "Arial");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrawNewItem(TObject *Sender, TCanvas *ACanvas,
   const TRect &ARect, bool Selected)
{
   TMenuItem *MenuItem = ((TMenuItem*)Sender);

   // Get the size of the menu that has been set aside for the checkmark
   CheckmarkSize = GetSystemMetrics(SM_CXMENUCHECK);
   MenuHeight = ARect.Height() * MenuItem->Parent->Count;
   VerticalBarLength = MenuHeight / 4;

   if(!VerticalBarDrawn)
   {
      OldFont = (TFont*)SelectObject(ACanvas->Handle,CreateFontIndirect(&VerticalFont));
      OldForegroundColor = SetTextColor(ACanvas->Handle, clWhite);
      OldBackgroundColor = SetBkColor(ACanvas->Handle, clRed);

      VerticalDrawingRect = Rect(0, 0, CheckmarkSize+TEXT_SPACE, MenuHeight);
      VerticalText = VerticalText.StringOfChar(' ',VerticalBarLength);
      VerticalText.Insert(" Vertical Text",1);

      ExtTextOut(ACanvas->Handle, -1, MenuHeight, ETO_CLIPPED,
         &VerticalDrawingRect, VerticalText.c_str(), VerticalBarLength, NULL);

      SelectObject(ACanvas->Handle,OldFont);
      SetTextColor(ACanvas->Handle, OldForegroundColor);
      SetBkColor(ACanvas->Handle, OldBackgroundColor);
      VerticalBarDrawn = true;
   }

   TempRect = ARect;
   TempRect.Left += LOWORD(CheckmarkSize)+ICON_SPACE;

   ACanvas->Pen->Style = psClear;

   ACanvas->Rectangle(
      TempRect.Left-MENU_TEXT_LEFT,
      MenuItem->MenuIndex*MENU_ITEM_OFFSET-SPACE_BETWEEN_MENUS,
      ARect.Width(),
      MenuItem->MenuIndex*MENU_ITEM_OFFSET+MENU_TEXT_HEIGHT);
   
   DrawText(ACanvas->Handle,MenuItem->Caption.c_str(),MenuItem->Caption.Length(),
      &TempRect, 0);

   if(Selected)
   {

      ACanvas->Pen->Style = psSolid;
      ACanvas->Pen->Color = clWhite;
      ACanvas->Rectangle(
         24,
         MenuItem->MenuIndex * MENU_ITEM_OFFSET-1,
         24+MENU_ITEM_OFFSET,
         MenuItem->MenuIndex * MENU_ITEM_OFFSET+MENU_TEXT_HEIGHT-1);

      ACanvas->Pen->Color = clGray;
      ACanvas->Rectangle(
         25,
         MenuItem->MenuIndex * MENU_ITEM_OFFSET,
         24+MENU_ITEM_OFFSET,
         MenuItem->MenuIndex * MENU_ITEM_OFFSET+MENU_TEXT_HEIGHT-1);

      ImageList1->GetIcon(MenuItem->ImageIndex,Icon);
      ACanvas->Draw(26,MenuItem->MenuIndex * MENU_ITEM_OFFSET,Icon);

   }
   else
   {
      ACanvas->Pen->Style = psClear;

      ACanvas->Rectangle(
      24,
      MenuItem->MenuIndex * MENU_ITEM_OFFSET-2,
      25+MENU_ITEM_OFFSET+2,
      MenuItem->MenuIndex * MENU_ITEM_OFFSET+MENU_TEXT_HEIGHT+2);

      ImageList1->GetIcon(MenuItem->ImageIndex,Icon);
      ACanvas->Draw(26,MenuItem->MenuIndex * MENU_ITEM_OFFSET,Icon);

   }
   ACanvas->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
   delete Icon;
}
//---------------------------------------------------------------------------


